#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
#define int ll

mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

// struct segtree {
//     int n;
//     vector<pair<int, int>> t;
//     segtree() = default;
//     segtree(int n_) {
//         n = n_;
//         t.resize()
//     }
// };

void solve() {
    int n, k; cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    if (k == 1) {
        int mx = 0;
        for (int i = 0; i < n; i++) mx = max(mx, a[i] + i + 1);
        cout << mx << '\n';
        return;
    }

    multiset<int> st;
    int S = 0;
    for (int i = 0; i < k - 1; i++) {
        st.insert(a[i]); S += a[i];
    }
    int ans = S + a[k - 1] + k;
    for (int i = k; i < n; i++) {
        if (*st.begin() < a[i - 1]) {
            S -= *st.begin();
            st.erase(st.begin());
            S += a[i - 1];
            st.insert(a[i - 1]);
        }
        ans = max(ans, S + a[i] + i + 1);
    }
    cout << ans << '\n';
}   

signed main() {
    int tt = 1;
    #ifdef LOCAL
        freopen("in.txt", "r", stdin);
        freopen("out.txt", "w", stdout);
        cin >> tt;
    #else
        cin.tie(0)->sync_with_stdio(false);
    #endif  

    while (tt--) {
        solve();
    }

    return 0;
}